diff --git a/sys/dev/raid/arcmsr/arcmsr.c b/sys/dev/raid/arcmsr/arcmsr.c
index f08380d..f0467c8 100644
--- a/sys/dev/raid/arcmsr/arcmsr.c
+++ b/sys/dev/raid/arcmsr/arcmsr.c
@@ -2021,13 +2390,14 @@ static int arcmsr_iop_message_xfer(struct AdapterControlBlock *acb, union ccb *
 	switch(controlcode) {
 	case ARCMSR_MESSAGE_READ_RQBUFFER: {
 			u_int8_t *pQbuffer;
-			u_int8_t *ptmpQbuffer=pcmdmessagefld->messagedatabuffer;
+			u_int8_t *ptmpQbuffer = pcmdmessagefld->messagedatabuffer;
 			int32_t allxfer_len = 0;
 
+			ARCMSR_LOCK_ACQUIRE(&acb->qbuffer_lock);
 			while ((acb->rqbuf_firstindex != acb->rqbuf_lastindex)
 				&& (allxfer_len < 1031)) {
 				pQbuffer = &acb->rqbuffer[acb->rqbuf_firstindex];
-				memcpy(ptmpQbuffer, pQbuffer, 1);
+				*ptmpQbuffer = *pQbuffer;
 				acb->rqbuf_firstindex++;
 				acb->rqbuf_firstindex %= ARCMSR_MAX_QBUFFER;
 				ptmpQbuffer++;
@@ -2035,38 +2405,29 @@ static int arcmsr_iop_message_xfer(struct AdapterControlBlock *acb, union ccb *
 			}
 			if (acb->acb_flags & ACB_F_IOPDATA_OVERFLOW) {
 				struct QBUFFER  *prbuffer;
-				u_int8_t  *iop_data;
-				int32_t iop_len;
 
 				acb->acb_flags &= ~ACB_F_IOPDATA_OVERFLOW;
-				prbuffer=arcmsr_get_iop_rqbuffer(acb);
-				iop_data = (u_int8_t *)prbuffer->data;
-				iop_len =(u_int32_t)prbuffer->data_len;
-				while (iop_len > 0) {
-			        pQbuffer= &acb->rqbuffer[acb->rqbuf_lastindex];
-					memcpy(pQbuffer, iop_data, 1);
-					acb->rqbuf_lastindex++;
-					acb->rqbuf_lastindex %= ARCMSR_MAX_QBUFFER;
-					iop_data++;
-					iop_len--;
-				}
-				arcmsr_iop_message_read(acb);
+				prbuffer = arcmsr_get_iop_rqbuffer(acb);
+				if(arcmsr_Read_iop_rqbuffer_data(acb, prbuffer) == 0)
+					acb->acb_flags |= ACB_F_IOPDATA_OVERFLOW;
 			}
 			pcmdmessagefld->cmdmessage.Length = allxfer_len;
 			pcmdmessagefld->cmdmessage.ReturnCode = ARCMSR_MESSAGE_RETURNCODE_OK;
-			retvalue=ARCMSR_MESSAGE_SUCCESS;
+			retvalue = ARCMSR_MESSAGE_SUCCESS;
+			ARCMSR_LOCK_RELEASE(&acb->qbuffer_lock);
 		}
 		break;
 	case ARCMSR_MESSAGE_WRITE_WQBUFFER: {
 			int32_t my_empty_len, user_len, wqbuf_firstindex, wqbuf_lastindex;
 			u_int8_t *pQbuffer;
-			u_int8_t *ptmpuserbuffer=pcmdmessagefld->messagedatabuffer;
+			u_int8_t *ptmpuserbuffer = pcmdmessagefld->messagedatabuffer;
 
 			user_len = pcmdmessagefld->cmdmessage.Length;
+			ARCMSR_LOCK_ACQUIRE(&acb->qbuffer_lock);
 			wqbuf_lastindex = acb->wqbuf_lastindex;
 			wqbuf_firstindex = acb->wqbuf_firstindex;
 			if (wqbuf_lastindex != wqbuf_firstindex) {
-				arcmsr_post_ioctldata2iop(acb);
+				arcmsr_Write_data_2iop_wqbuffer(acb);
 				/* has error report sensedata */
 			    if(pccb->csio.sense_len) {
 				((u_int8_t *)&pccb->csio.sense_data)[0] = (0x1 << 7 | 0x70);
@@ -2085,7 +2446,7 @@ static int arcmsr_iop_message_xfer(struct AdapterControlBlock *acb, union ccb *
 				if (my_empty_len >= user_len) {
 					while (user_len > 0) {
 						pQbuffer = &acb->wqbuffer[acb->wqbuf_lastindex];
-						memcpy(pQbuffer, ptmpuserbuffer, 1);
+						*pQbuffer = *ptmpuserbuffer;
 						acb->wqbuf_lastindex++;
 						acb->wqbuf_lastindex %= ARCMSR_MAX_QBUFFER;
 						ptmpuserbuffer++;
@@ -2093,8 +2454,8 @@ static int arcmsr_iop_message_xfer(struct AdapterControlBlock *acb, union ccb *
 					}
 					if (acb->acb_flags & ACB_F_MESSAGE_WQBUFFER_CLEARED) {
 						acb->acb_flags &=
-						~ACB_F_MESSAGE_WQBUFFER_CLEARED;
-						arcmsr_post_ioctldata2iop(acb);
+						    ~ACB_F_MESSAGE_WQBUFFER_CLEARED;
+						arcmsr_Write_data_2iop_wqbuffer(acb);
 					}
 				} else {
 					/* has error report sensedata */
@@ -2111,11 +2472,13 @@ static int arcmsr_iop_message_xfer(struct AdapterControlBlock *acb, union ccb *
 					retvalue = ARCMSR_MESSAGE_FAIL;
 				}
 			}
+			ARCMSR_LOCK_RELEASE(&acb->qbuffer_lock);
 		}
 		break;
 	case ARCMSR_MESSAGE_CLEAR_RQBUFFER: {
 			u_int8_t *pQbuffer = acb->rqbuffer;
 
+			ARCMSR_LOCK_ACQUIRE(&acb->qbuffer_lock);
 			if (acb->acb_flags & ACB_F_IOPDATA_OVERFLOW) {
 				acb->acb_flags &= ~ACB_F_IOPDATA_OVERFLOW;
 				arcmsr_iop_message_read(acb);
@@ -2125,12 +2488,14 @@ static int arcmsr_iop_message_xfer(struct AdapterControlBlock *acb, union ccb *
 			acb->rqbuf_lastindex = 0;
 			memset(pQbuffer, 0, ARCMSR_MAX_QBUFFER);
 			pcmdmessagefld->cmdmessage.ReturnCode =
-			ARCMSR_MESSAGE_RETURNCODE_OK;
+			    ARCMSR_MESSAGE_RETURNCODE_OK;
+			ARCMSR_LOCK_RELEASE(&acb->qbuffer_lock);
 		}
 		break;
 	case ARCMSR_MESSAGE_CLEAR_WQBUFFER: {
 			u_int8_t *pQbuffer = acb->wqbuffer;
 
+			ARCMSR_LOCK_ACQUIRE(&acb->qbuffer_lock);
 			if (acb->acb_flags & ACB_F_IOPDATA_OVERFLOW) {
 				acb->acb_flags &= ~ACB_F_IOPDATA_OVERFLOW;
 				arcmsr_iop_message_read(acb);
@@ -2143,11 +2508,13 @@ static int arcmsr_iop_message_xfer(struct AdapterControlBlock *acb, union ccb *
 			memset(pQbuffer, 0, ARCMSR_MAX_QBUFFER);
 			pcmdmessagefld->cmdmessage.ReturnCode =
 				ARCMSR_MESSAGE_RETURNCODE_OK;
+			ARCMSR_LOCK_RELEASE(&acb->qbuffer_lock);
 		}
 		break;
 	case ARCMSR_MESSAGE_CLEAR_ALLQBUFFER: {
 			u_int8_t *pQbuffer;
 
+			ARCMSR_LOCK_ACQUIRE(&acb->qbuffer_lock);
 			if (acb->acb_flags & ACB_F_IOPDATA_OVERFLOW) {
 				acb->acb_flags &= ~ACB_F_IOPDATA_OVERFLOW;
 				arcmsr_iop_message_read(acb);
@@ -2165,6 +2532,7 @@ static int arcmsr_iop_message_xfer(struct AdapterControlBlock *acb, union ccb *
 			pQbuffer = acb->wqbuffer;
 			memset(pQbuffer, 0, sizeof (struct QBUFFER));
 			pcmdmessagefld->cmdmessage.ReturnCode = ARCMSR_MESSAGE_RETURNCODE_OK;
+			ARCMSR_LOCK_RELEASE(&acb->qbuffer_lock);
 		}
 		break;
 	case ARCMSR_MESSAGE_REQUEST_RETURNCODE_3F: {
@@ -2172,7 +2540,7 @@ static int arcmsr_iop_message_xfer(struct AdapterControlBlock *acb, union ccb *
 		}
 		break;
 	case ARCMSR_MESSAGE_SAY_HELLO: {
-			int8_t * hello_string = "Hello! I am ARCMSR";
+			int8_t *hello_string = "Hello! I am ARCMSR";
 
 			memcpy(pcmdmessagefld->messagedatabuffer, hello_string
 				, (int16_t)strlen(hello_string));
@@ -2197,17 +2565,15 @@ message_out:
 */
 static void arcmsr_execute_srb(void *arg, bus_dma_segment_t *dm_segs, int nseg, int error)
 {
-	struct CommandControlBlock *srb=(struct CommandControlBlock *)arg;
-	struct AdapterControlBlock *acb=(struct AdapterControlBlock *)srb->acb;
-	union ccb * pccb;
+	struct CommandControlBlock *srb = (struct CommandControlBlock *)arg;
+	struct AdapterControlBlock *acb = (struct AdapterControlBlock *)srb->acb;
+	union ccb *pccb;
 	int target, lun;
 
-	pccb=srb->pccb;
-	target=pccb->ccb_h.target_id;
-	lun=pccb->ccb_h.target_lun;
-#ifdef ARCMSR_DEBUG1
+	pccb = srb->pccb;
+	target = pccb->ccb_h.target_id;
+	lun = pccb->ccb_h.target_lun;
 	acb->pktRequestCount++;
-#endif
 	if(error != 0) {
 		if(error != EFBIG) {
 			kprintf("arcmsr%d: unexpected error %x"
@@ -2231,12 +2597,12 @@ static void arcmsr_execute_srb(void *arg, bus_dma_segment_t *dm_segs, int nseg,
 		arcmsr_srb_complete(srb, 0);
 		return;
 	}
-	if(acb->devstate[target][lun]==ARECA_RAID_GONE) {
+	if(acb->devstate[target][lun] == ARECA_RAID_GONE) {
 		u_int8_t block_cmd, cmd;
 
 		cmd = pccb->csio.cdb_io.cdb_bytes[0];
-		block_cmd= cmd & 0x0f;
-		if(block_cmd==0x08 || block_cmd==0x0a) {
+		block_cmd = cmd & 0x0f;
+		if(block_cmd == 0x08 || block_cmd == 0x0a) {
 			kprintf("arcmsr%d:block 'read/write' command "
 				"with gone raid volume Cmd=0x%2x, TargetId=%d, Lun=%d \n"
 				, acb->pci_unit, cmd, target, lun);
@@ -2252,10 +2618,14 @@ static void arcmsr_execute_srb(void *arg, bus_dma_segment_t *dm_segs, int nseg,
 		arcmsr_srb_complete(srb, 0);
 		return;
 	}
-	if(acb->srboutstandingcount > ARCMSR_MAX_OUTSTANDING_CMD) {
-		xpt_freeze_simq(acb->psim, 1);
-		pccb->ccb_h.status = CAM_REQUEUE_REQ;
-		acb->acb_flags |= ACB_F_CAM_DEV_QFRZN;
+	if(acb->srboutstandingcount >= acb->maxOutstanding) {
+		if((acb->acb_flags & ACB_F_CAM_DEV_QFRZN) == 0)
+		{
+			xpt_freeze_simq(acb->psim, 1);
+			acb->acb_flags |= ACB_F_CAM_DEV_QFRZN;
+		}
+		pccb->ccb_h.status &= ~CAM_SIM_QUEUED;
+		pccb->ccb_h.status |= CAM_REQUEUE_REQ;
 		arcmsr_srb_complete(srb, 0);
 		return;
 	}
@@ -2273,12 +2643,12 @@ static void arcmsr_execute_srb(void *arg, bus_dma_segment_t *dm_segs, int nseg,
 *****************************************************************************************
 *****************************************************************************************
 */
-static u_int8_t arcmsr_seek_cmd2abort(union ccb * abortccb)
+static u_int8_t arcmsr_seek_cmd2abort(union ccb *abortccb)
 {
 	struct CommandControlBlock *srb;
-	struct AdapterControlBlock *acb=(struct AdapterControlBlock *) abortccb->ccb_h.arcmsr_ccbacb_ptr;
+	struct AdapterControlBlock *acb = (struct AdapterControlBlock *) abortccb->ccb_h.arcmsr_ccbacb_ptr;
 	u_int32_t intmask_org;
-	int i=0;
+	int i = 0;
 
 	acb->num_aborts++;
 	/*
@@ -2290,18 +2660,18 @@ static u_int8_t arcmsr_seek_cmd2abort(union ccb * abortccb)
 	** command return success.
 	***************************************************************************
 	*/
-	if(acb->srboutstandingcount!=0) {
+	if(acb->srboutstandingcount != 0) {
 		/* disable all outbound interrupt */
-		intmask_org=arcmsr_disable_allintr(acb);
-		for(i=0;i<ARCMSR_MAX_FREESRB_NUM;i++) {
-			srb=acb->psrb_pool[i];
-			if(srb->srb_state==ARCMSR_SRB_START) {
-				if(srb->pccb==abortccb) {
-					srb->srb_state=ARCMSR_SRB_ABORTED;
-					kprintf("arcmsr%d:scsi id=%d lun=%d abort srb '%p'"
+		intmask_org = arcmsr_disable_allintr(acb);
+		for(i=0; i < ARCMSR_MAX_FREESRB_NUM; i++) {
+			srb = acb->psrb_pool[i];
+			if(srb->srb_state == ARCMSR_SRB_START) {
+				if(srb->pccb == abortccb) {
+					srb->srb_state = ARCMSR_SRB_ABORTED;
+					kprintf("arcmsr%d:scsi id=%d lun=%jx abort srb '%p'"
 						"outstanding command \n"
 						, acb->pci_unit, abortccb->ccb_h.target_id
-						, abortccb->ccb_h.target_lun, srb);
+						, (uintmax_t)abortccb->ccb_h.target_lun, srb);
 					arcmsr_polling_srbdone(acb, srb);
 					/* enable outbound Post Queue, outbound doorbell Interrupt */
 					arcmsr_enable_allintr(acb, intmask_org);
@@ -2320,11 +2690,11 @@ static u_int8_t arcmsr_seek_cmd2abort(union ccb * abortccb)
 */
 static void arcmsr_bus_reset(struct AdapterControlBlock *acb)
 {
-	int retry=0;
+	int retry = 0;
 
 	acb->num_resets++;
-	acb->acb_flags |=ACB_F_BUS_RESET;
-	while(acb->srboutstandingcount!=0 && retry < 400) {
+	acb->acb_flags |= ACB_F_BUS_RESET;
+	while(acb->srboutstandingcount != 0 && retry < 400) {
 		arcmsr_interrupt(acb);
 		UDELAY(25000);
 		retry++;
@@ -2337,19 +2707,19 @@ static void arcmsr_bus_reset(struct AdapterControlBlock *acb)
 **************************************************************************
 */
 static void arcmsr_handle_virtual_command(struct AdapterControlBlock *acb,
-		union ccb * pccb)
+		union ccb *pccb)
 {
+	if (pccb->ccb_h.target_lun) {
+		pccb->ccb_h.status |= CAM_DEV_NOT_THERE;
+		xpt_done(pccb);
+		return;
+	}
 	pccb->ccb_h.status |= CAM_REQ_CMP;
 	switch (pccb->csio.cdb_io.cdb_bytes[0]) {
 	case INQUIRY: {
 		unsigned char inqdata[36];
-		char *buffer=pccb->csio.data_ptr;
+		char *buffer = pccb->csio.data_ptr;
 
-		if (pccb->ccb_h.target_lun) {
-			pccb->ccb_h.status |= CAM_SEL_TIMEOUT;
-			xpt_done(pccb);
-			return;
-		}
 		inqdata[0] = T_PROCESSOR;	/* Periph Qualifier & Periph Dev Type */
 		inqdata[1] = 0;				/* rem media bit & Dev Type Modifier */
 		inqdata[2] = 0;				/* ISO, ECMA, & ANSI versions */
@@ -2382,12 +2752,12 @@ static void arcmsr_handle_virtual_command(struct AdapterControlBlock *acb,
 *********************************************************************
 *********************************************************************
 */
-static void arcmsr_action(struct cam_sim * psim, union ccb * pccb)
+static void arcmsr_action(struct cam_sim *psim, union ccb *pccb)
 {
-	struct AdapterControlBlock *  acb;
+	struct AdapterControlBlock *acb;
 
-	acb=(struct AdapterControlBlock *) cam_sim_softc(psim);
-	if(acb==NULL) {
+	acb = (struct AdapterControlBlock *) cam_sim_softc(psim);
+	if(acb == NULL) {
 		pccb->ccb_h.status |= CAM_REQ_INVALID;
 		xpt_done(pccb);
 		return;
@@ -2395,14 +2765,14 @@ static void arcmsr_action(struct cam_sim * psim, union ccb * pccb)
 	switch (pccb->ccb_h.func_code) {
 	case XPT_SCSI_IO: {
 			struct CommandControlBlock *srb;
-			int target=pccb->ccb_h.target_id;
+			int target = pccb->ccb_h.target_id;
 
 			if(target == 16) {
 				/* virtual device for iop message transfer */
 				arcmsr_handle_virtual_command(acb, pccb);
 				return;
 			}
-			if((srb=arcmsr_get_freesrb(acb)) == NULL) {
+			if((srb = arcmsr_get_freesrb(acb)) == NULL) {
 				pccb->ccb_h.status |= CAM_RESRC_UNAVAIL;
 				xpt_done(pccb);
 				return;
@@ -2462,27 +2832,30 @@ static void arcmsr_action(struct cam_sim * psim, union ccb * pccb)
 			break;
 		}
 	case XPT_PATH_INQ: {
-			struct ccb_pathinq *cpi= &pccb->cpi;
-
-			cpi->version_num=1;
-			cpi->hba_inquiry=PI_SDTR_ABLE | PI_TAG_ABLE;
-			cpi->target_sprt=0;
-			cpi->hba_misc=0;
-			cpi->hba_eng_cnt=0;
-			cpi->max_target=ARCMSR_MAX_TARGETID;        /* 0-16 */
-			cpi->max_lun=ARCMSR_MAX_TARGETLUN;	    /* 0-7 */
-			cpi->initiator_id=ARCMSR_SCSI_INITIATOR_ID; /* 255 */
-			cpi->bus_id=cam_sim_bus(psim);
+			struct ccb_pathinq *cpi = &pccb->cpi;
+
+			cpi->version_num = 1;
+			cpi->hba_inquiry = PI_SDTR_ABLE | PI_TAG_ABLE;
+			cpi->target_sprt = 0;
+			cpi->hba_misc = 0;
+			cpi->hba_eng_cnt = 0;
+			cpi->max_target = ARCMSR_MAX_TARGETID;        /* 0-16 */
+			cpi->max_lun = ARCMSR_MAX_TARGETLUN;	    /* 0-7 */
+			cpi->initiator_id = ARCMSR_SCSI_INITIATOR_ID; /* 255 */
+			cpi->bus_id = cam_sim_bus(psim);
 			strncpy(cpi->sim_vid, "FreeBSD", SIM_IDLEN);
 			strncpy(cpi->hba_vid, "ARCMSR", HBA_IDLEN);
 			strncpy(cpi->dev_name, cam_sim_name(psim), DEV_IDLEN);
-			cpi->unit_number=cam_sim_unit(psim);
-			if(acb->adapter_bus_speed == ACB_BUS_SPEED_6G)
+			cpi->unit_number = cam_sim_unit(psim);
+			if(acb->adapter_bus_speed == ACB_BUS_SPEED_12G)
+				cpi->base_transfer_speed = 1200000;
+			else if(acb->adapter_bus_speed == ACB_BUS_SPEED_6G)
 				cpi->base_transfer_speed = 600000;
 			else
 				cpi->base_transfer_speed = 300000;
 			if((acb->vendor_device_id == PCIDevVenIDARC1880) ||
-			   (acb->vendor_device_id == PCIDevVenIDARC1680))
+			   (acb->vendor_device_id == PCIDevVenIDARC1680) ||
+			   (acb->vendor_device_id == PCIDevVenIDARC1214))
 			{
 				cpi->transport = XPORT_SAS;
 				cpi->transport_version = 0;
@@ -2502,7 +2875,7 @@ static void arcmsr_action(struct cam_sim * psim, union ccb * pccb)
 	case XPT_ABORT: {
 			union ccb *pabort_ccb;
 
-			pabort_ccb=pccb->cab.abort_ccb;
+			pabort_ccb = pccb->cab.abort_ccb;
 			switch (pabort_ccb->ccb_h.func_code) {
 			case XPT_ACCEPT_TARGET_IO:
 			case XPT_IMMED_NOTIFY:
@@ -2552,7 +2925,7 @@ static void arcmsr_action(struct cam_sim * psim, union ccb * pccb)
 				xpt_done(pccb);
 				break;
 			}
-			cts= &pccb->cts;
+			cts = &pccb->cts;
 			{
 				struct ccb_trans_settings_scsi *scsi;
 				struct ccb_trans_settings_spi *spi;
@@ -2564,14 +2937,18 @@ static void arcmsr_action(struct cam_sim * psim, union ccb * pccb)
 				cts->protocol = PROTO_SCSI;
 
 				if((acb->vendor_device_id == PCIDevVenIDARC1880) ||
-				   (acb->vendor_device_id == PCIDevVenIDARC1680))
+				   (acb->vendor_device_id == PCIDevVenIDARC1680) ||
+				   (acb->vendor_device_id == PCIDevVenIDARC1214))
 				{
 					cts->protocol_version = SCSI_REV_SPC2;
 					cts->transport_version = 0;
 					cts->transport = XPORT_SAS;
 					sas = &cts->xport_specific.sas;
 					sas->valid = CTS_SAS_VALID_SPEED;
-					if(acb->vendor_device_id == PCIDevVenIDARC1880)
+					if (acb->sub_device_id == ARECA_SUB_DEV_ID_1883)
+						sas->bitrate = 1200000;
+					else if((acb->vendor_device_id == PCIDevVenIDARC1880) ||
+					   (acb->vendor_device_id == PCIDevVenIDARC1214))
 						sas->bitrate = 600000;
 					else if(acb->vendor_device_id == PCIDevVenIDARC1680)
 						sas->bitrate = 300000;
@@ -2583,9 +2960,9 @@ static void arcmsr_action(struct cam_sim * psim, union ccb * pccb)
 					cts->transport = XPORT_SPI;
 					spi = &cts->xport_specific.spi;
 					spi->flags = CTS_SPI_FLAGS_DISC_ENB;
-					spi->sync_period=2;
-					spi->sync_offset=32;
-					spi->bus_width=MSG_EXT_WDTR_BUS_16_BIT;
+					spi->sync_period = 2;
+					spi->sync_offset = 32;
+					spi->bus_width = MSG_EXT_WDTR_BUS_16_BIT;
 					spi->valid = CTS_SPI_VALID_DISC
 						| CTS_SPI_VALID_SYNC_RATE
 						| CTS_SPI_VALID_SYNC_OFFSET
@@ -2657,6 +3034,18 @@ static void arcmsr_start_hbc_bgrb(struct AdapterControlBlock *acb)
 **********************************************************************
 **********************************************************************
 */
+static void arcmsr_start_hbd_bgrb(struct AdapterControlBlock *acb)
+{
+	acb->acb_flags |= ACB_F_MSG_START_BGRB;
+	CHIP_REG_WRITE32(HBD_MessageUnit, 0, inbound_msgaddr0, ARCMSR_INBOUND_MESG0_START_BGRB);
+	if(!arcmsr_hbd_wait_msgint_ready(acb)) {
+		kprintf("arcmsr%d: wait 'start adapter background rebulid' timeout \n", acb->pci_unit);
+	}
+}
+/*
+**********************************************************************
+**********************************************************************
+*/
 static void arcmsr_start_adapter_bgrb(struct AdapterControlBlock *acb)
 {
 	switch (acb->adapter_type) {
@@ -2669,6 +3058,9 @@ static void arcmsr_start_adapter_bgrb(struct AdapterControlBlock *acb)
 	case ACB_ADAPTER_TYPE_C:
 		arcmsr_start_hbc_bgrb(acb);
 		break;
+	case ACB_ADAPTER_TYPE_D:
+		arcmsr_start_hbd_bgrb(acb);
+		break;
 	}
 }
 /*
@@ -2688,8 +3080,8 @@ polling_ccb_retry:
 	CHIP_REG_WRITE32(HBA_MessageUnit, 0, outbound_intstatus, outbound_intstatus);	/*clear interrupt*/
 	bus_dmamap_sync(acb->srb_dmat, acb->srb_dmamap, BUS_DMASYNC_POSTREAD|BUS_DMASYNC_POSTWRITE);
 	while(1) {
-		if((flag_srb=CHIP_REG_READ32(HBA_MessageUnit,
-			0, outbound_queueport))==0xFFFFFFFF) {
+		if((flag_srb = CHIP_REG_READ32(HBA_MessageUnit, 
+			0, outbound_queueport)) == 0xFFFFFFFF) {
 			if(poll_srb_done) {
 				break;/*chip FIFO no ccb for completion already*/
 			} else {
@@ -2701,17 +3093,17 @@ polling_ccb_retry:
 			}
 		}
 		/* check if command done with no error*/
-		srb=(struct CommandControlBlock *)
+		srb = (struct CommandControlBlock *)
 			(acb->vir2phy_offset+(flag_srb << 5));/*frame must be 32 bytes aligned*/
-        error=(flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE0)?TRUE:FALSE;
-		poll_srb_done = (srb==poll_srb) ? 1:0;
-		if((srb->acb!=acb) || (srb->srb_state!=ARCMSR_SRB_START)) {
-			if(srb->srb_state==ARCMSR_SRB_ABORTED) {
-				kprintf("arcmsr%d: scsi id=%d lun=%d srb='%p'"
+        error = (flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE0)?TRUE:FALSE;
+		poll_srb_done = (srb == poll_srb) ? 1:0;
+		if((srb->acb != acb) || (srb->srb_state != ARCMSR_SRB_START)) {
+			if(srb->srb_state == ARCMSR_SRB_ABORTED) {
+				kprintf("arcmsr%d: scsi id=%d lun=%jx srb='%p'"
 					"poll command abort successfully \n"
 					, acb->pci_unit
 					, srb->pccb->ccb_h.target_id
-					, srb->pccb->ccb_h.target_lun, srb);
+					, (uintmax_t)srb->pccb->ccb_h.target_lun, srb);
 				srb->pccb->ccb_h.status |= CAM_REQ_ABORTED;
 				arcmsr_srb_complete(srb, 1);
 				continue;
@@ -2732,7 +3124,7 @@ polling_ccb_retry:
 */
 static void arcmsr_polling_hbb_srbdone(struct AdapterControlBlock *acb, struct CommandControlBlock *poll_srb)
 {
-	struct HBB_MessageUnit *phbbmu=(struct HBB_MessageUnit *)acb->pmu;
+	struct HBB_MessageUnit *phbbmu = (struct HBB_MessageUnit *)acb->pmu;
 	struct CommandControlBlock *srb;
 	u_int32_t flag_srb, poll_srb_done=0, poll_count=0;
 	int index;
@@ -2744,8 +3136,8 @@ polling_ccb_retry:
 	0, iop2drv_doorbell, ARCMSR_DOORBELL_INT_CLEAR_PATTERN); /* clear doorbell interrupt */
 	bus_dmamap_sync(acb->srb_dmat, acb->srb_dmamap, BUS_DMASYNC_POSTREAD|BUS_DMASYNC_POSTWRITE);
 	while(1) {
-		index=phbbmu->doneq_index;
-		if((flag_srb=phbbmu->done_qbuffer[index]) == 0) {
+		index = phbbmu->doneq_index;
+		if((flag_srb = phbbmu->done_qbuffer[index]) == 0) {
 			if(poll_srb_done) {
 				break;/*chip FIFO no ccb for completion already*/
 			} else {
@@ -2756,22 +3148,22 @@ polling_ccb_retry:
 				goto polling_ccb_retry;
 			}
 		}
-		phbbmu->done_qbuffer[index]=0;
+		phbbmu->done_qbuffer[index] = 0;
 		index++;
 		index %= ARCMSR_MAX_HBB_POSTQUEUE;     /*if last index number set it to 0 */
-		phbbmu->doneq_index=index;
+		phbbmu->doneq_index = index;
 		/* check if command done with no error*/
-		srb=(struct CommandControlBlock *)
+		srb = (struct CommandControlBlock *)
 			(acb->vir2phy_offset+(flag_srb << 5));/*frame must be 32 bytes aligned*/
-        error=(flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE0)?TRUE:FALSE;
-		poll_srb_done = (srb==poll_srb) ? 1:0;
-		if((srb->acb!=acb) || (srb->srb_state!=ARCMSR_SRB_START)) {
-			if(srb->srb_state==ARCMSR_SRB_ABORTED) {
-				kprintf("arcmsr%d: scsi id=%d lun=%d srb='%p'"
+        error = (flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE0)?TRUE:FALSE;
+		poll_srb_done = (srb == poll_srb) ? 1:0;
+		if((srb->acb != acb) || (srb->srb_state != ARCMSR_SRB_START)) {
+			if(srb->srb_state == ARCMSR_SRB_ABORTED) {
+				kprintf("arcmsr%d: scsi id=%d lun=%jx srb='%p'"
 					"poll command abort successfully \n"
 					, acb->pci_unit
 					, srb->pccb->ccb_h.target_id
-					, srb->pccb->ccb_h.target_lun, srb);
+					, (uintmax_t)srb->pccb->ccb_h.target_lun, srb);
 				srb->pccb->ccb_h.status |= CAM_REQ_ABORTED;
 				arcmsr_srb_complete(srb, 1);
 				continue;
@@ -2816,14 +3208,70 @@ polling_ccb_retry:
 		}
 		flag_srb = CHIP_REG_READ32(HBC_MessageUnit, 0, outbound_queueport_low);
 		/* check if command done with no error*/
-		srb=(struct CommandControlBlock *)(acb->vir2phy_offset+(flag_srb & 0xFFFFFFE0));/*frame must be 32 bytes aligned*/
-        error=(flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE1)?TRUE:FALSE;
+		srb = (struct CommandControlBlock *)(acb->vir2phy_offset+(flag_srb & 0xFFFFFFE0));/*frame must be 32 bytes aligned*/
+        error = (flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE1)?TRUE:FALSE;
+		if (poll_srb != NULL)
+			poll_srb_done = (srb == poll_srb) ? 1:0;
+		if((srb->acb != acb) || (srb->srb_state != ARCMSR_SRB_START)) {
+			if(srb->srb_state == ARCMSR_SRB_ABORTED) {
+				kprintf("arcmsr%d: scsi id=%d lun=%jx srb='%p'poll command abort successfully \n"
+						, acb->pci_unit, srb->pccb->ccb_h.target_id, (uintmax_t)srb->pccb->ccb_h.target_lun, srb);
+				srb->pccb->ccb_h.status |= CAM_REQ_ABORTED;
+				arcmsr_srb_complete(srb, 1);
+				continue;
+			}
+			kprintf("arcmsr%d: polling get an illegal srb command done srb='%p'srboutstandingcount=%d \n"
+					, acb->pci_unit, srb, acb->srboutstandingcount);
+			continue;
+		}
+		arcmsr_report_srb_state(acb, srb, error);
+	}	/*drain reply FIFO*/
+}
+/*
+**********************************************************************
+** 
+**********************************************************************
+*/
+static void arcmsr_polling_hbd_srbdone(struct AdapterControlBlock *acb, struct CommandControlBlock *poll_srb)
+{
+	struct HBD_MessageUnit0 *phbdmu = (struct HBD_MessageUnit0 *)acb->pmu;
+	struct CommandControlBlock *srb;
+	u_int32_t flag_srb, poll_srb_done=0, poll_count=0;
+	u_int32_t outbound_write_pointer;
+	u_int16_t	error, doneq_index;
+	
+polling_ccb_retry:
+	poll_count++;
+	bus_dmamap_sync(acb->srb_dmat, acb->srb_dmamap, BUS_DMASYNC_POSTREAD|BUS_DMASYNC_POSTWRITE);
+	while(1) {
+		outbound_write_pointer = phbdmu->done_qbuffer[0].addressLow;
+		doneq_index = phbdmu->doneq_index;
+		if ((outbound_write_pointer & 0xFF) == (doneq_index & 0xFF)) {
+			if(poll_srb_done) {
+				break;/*chip FIFO no ccb for completion already*/
+			} else {
+				UDELAY(25000);
+			    if ((poll_count > 100) && (poll_srb != NULL)) {
+					break;
+				}
+			    if (acb->srboutstandingcount == 0) {
+				    break;
+			    }
+				goto polling_ccb_retry;
+			}
+		}
+		doneq_index = arcmsr_get_doneq_index(phbdmu);
+		flag_srb = phbdmu->done_qbuffer[(doneq_index & 0xFF)+1].addressLow;
+		/* check if command done with no error*/
+		srb = (struct CommandControlBlock *)(acb->vir2phy_offset+(flag_srb & 0xFFFFFFE0));/*frame must be 32 bytes aligned*/
+        error = (flag_srb & ARCMSR_SRBREPLY_FLAG_ERROR_MODE1) ? TRUE : FALSE;
+		CHIP_REG_WRITE32(HBD_MessageUnit, 0, outboundlist_read_pointer, doneq_index);
 		if (poll_srb != NULL)
-			poll_srb_done = (srb==poll_srb) ? 1:0;
-		if((srb->acb!=acb) || (srb->srb_state!=ARCMSR_SRB_START)) {
-			if(srb->srb_state==ARCMSR_SRB_ABORTED) {
-				kprintf("arcmsr%d: scsi id=%d lun=%d srb='%p'poll command abort successfully \n"
-						, acb->pci_unit, srb->pccb->ccb_h.target_id, srb->pccb->ccb_h.target_lun, srb);
+			poll_srb_done = (srb == poll_srb) ? 1:0;
+		if((srb->acb != acb) || (srb->srb_state != ARCMSR_SRB_START)) {
+			if(srb->srb_state == ARCMSR_SRB_ABORTED) {
+				kprintf("arcmsr%d: scsi id=%d lun=%jx srb='%p'poll command abort successfully \n"
+						, acb->pci_unit, srb->pccb->ccb_h.target_id, (uintmax_t)srb->pccb->ccb_h.target_lun, srb);
 				srb->pccb->ccb_h.status |= CAM_REQ_ABORTED;
 				arcmsr_srb_complete(srb, 1);
 				continue;
@@ -2854,6 +3302,10 @@ static void arcmsr_polling_srbdone(struct AdapterControlBlock *acb, struct Comma
 			arcmsr_polling_hbc_srbdone(acb, poll_srb);
 		}
 		break;
+	case ACB_ADAPTER_TYPE_D: {
+			arcmsr_polling_hbd_srbdone(acb, poll_srb);
+		}
+		break;
 	}
 }
 /*
@@ -2862,11 +3314,11 @@ static void arcmsr_polling_srbdone(struct AdapterControlBlock *acb, struct Comma
 */
 static void arcmsr_get_hba_config(struct AdapterControlBlock *acb)
 {
-	char *acb_firm_model=acb->firm_model;
-	char *acb_firm_version=acb->firm_version;
+	char *acb_firm_model = acb->firm_model;
+	char *acb_firm_version = acb->firm_version;
 	char *acb_device_map = acb->device_map;
-	size_t iop_firm_model=offsetof(struct HBA_MessageUnit,msgcode_rwbuffer[ARCMSR_FW_MODEL_OFFSET]);	/*firm_model,15,60-67*/
-	size_t iop_firm_version=offsetof(struct HBA_MessageUnit,msgcode_rwbuffer[ARCMSR_FW_VERS_OFFSET]);	/*firm_version,17,68-83*/
+	size_t iop_firm_model = offsetof(struct HBA_MessageUnit,msgcode_rwbuffer[ARCMSR_FW_MODEL_OFFSET]);	/*firm_model,15,60-67*/
+	size_t iop_firm_version = offsetof(struct HBA_MessageUnit,msgcode_rwbuffer[ARCMSR_FW_VERS_OFFSET]);	/*firm_version,17,68-83*/
 	size_t iop_device_map = offsetof(struct HBA_MessageUnit,msgcode_rwbuffer[ARCMSR_FW_DEVMAP_OFFSET]);
 	int i;
 
@@ -2874,33 +3326,36 @@ static void arcmsr_get_hba_config(struct AdapterControlBlock *acb)
 	if(!arcmsr_hba_wait_msgint_ready(acb)) {
 		kprintf("arcmsr%d: wait 'get adapter firmware miscellaneous data' timeout \n", acb->pci_unit);
 	}
-	i=0;
-	while(i<8) {
-		*acb_firm_model=bus_space_read_1(acb->btag[0], acb->bhandle[0], iop_firm_model+i);
+	i = 0;
+	while(i < 8) {
+		*acb_firm_model = bus_space_read_1(acb->btag[0], acb->bhandle[0], iop_firm_model+i); 
 		/* 8 bytes firm_model, 15, 60-67*/
 		acb_firm_model++;
 		i++;
 	}
 	i=0;
-	while(i<16) {
-		*acb_firm_version=bus_space_read_1(acb->btag[0], acb->bhandle[0], iop_firm_version+i);
+	while(i < 16) {
+		*acb_firm_version = bus_space_read_1(acb->btag[0], acb->bhandle[0], iop_firm_version+i);  
 		/* 16 bytes firm_version, 17, 68-83*/
 		acb_firm_version++;
 		i++;
 	}
 	i=0;
-	while(i<16) {
-		*acb_device_map=bus_space_read_1(acb->btag[0], acb->bhandle[0], iop_device_map+i);
+	while(i < 16) {
+		*acb_device_map = bus_space_read_1(acb->btag[0], acb->bhandle[0], iop_device_map+i);  
 		acb_device_map++;
 		i++;
 	}
-	kprintf("ARECA RAID ADAPTER%d: %s \n", acb->pci_unit, ARCMSR_DRIVER_VERSION);
-	kprintf("ARECA RAID ADAPTER%d: FIRMWARE VERSION %s \n", acb->pci_unit, acb->firm_version);
-	acb->firm_request_len=CHIP_REG_READ32(HBA_MessageUnit, 0, msgcode_rwbuffer[1]);   /*firm_request_len, 1, 04-07*/
-	acb->firm_numbers_queue=CHIP_REG_READ32(HBA_MessageUnit, 0, msgcode_rwbuffer[2]); /*firm_numbers_queue, 2, 08-11*/
-	acb->firm_sdram_size=CHIP_REG_READ32(HBA_MessageUnit, 0, msgcode_rwbuffer[3]);    /*firm_sdram_size, 3, 12-15*/
-	acb->firm_ide_channels=CHIP_REG_READ32(HBA_MessageUnit, 0, msgcode_rwbuffer[4]);  /*firm_ide_channels, 4, 16-19*/
-	acb->firm_cfg_version=CHIP_REG_READ32(HBA_MessageUnit, 0, msgcode_rwbuffer[ARCMSR_FW_CFGVER_OFFSET]);	/*firm_cfg_version,  25,	  */
+	kprintf("Areca RAID adapter%d: %s F/W version %s \n", acb->pci_unit, acb->firm_model, acb->firm_version);
+	acb->firm_request_len = CHIP_REG_READ32(HBA_MessageUnit, 0, msgcode_rwbuffer[1]);   /*firm_request_len, 1, 04-07*/
+	acb->firm_numbers_queue = CHIP_REG_READ32(HBA_MessageUnit, 0, msgcode_rwbuffer[2]); /*firm_numbers_queue, 2, 08-11*/
+	acb->firm_sdram_size = CHIP_REG_READ32(HBA_MessageUnit, 0, msgcode_rwbuffer[3]);    /*firm_sdram_size, 3, 12-15*/
+	acb->firm_ide_channels = CHIP_REG_READ32(HBA_MessageUnit, 0, msgcode_rwbuffer[4]);  /*firm_ide_channels, 4, 16-19*/
+	acb->firm_cfg_version = CHIP_REG_READ32(HBA_MessageUnit, 0, msgcode_rwbuffer[ARCMSR_FW_CFGVER_OFFSET]);	/*firm_cfg_version,  25, 	  */
+	if(acb->firm_numbers_queue > ARCMSR_MAX_OUTSTANDING_CMD)
+		acb->maxOutstanding = ARCMSR_MAX_OUTSTANDING_CMD - 1;
+	else
+		acb->maxOutstanding = acb->firm_numbers_queue - 1;
 }
 /*
 **********************************************************************
@@ -2908,11 +3363,11 @@ static void arcmsr_get_hba_config(struct AdapterControlBlock *acb)
 */
 static void arcmsr_get_hbb_config(struct AdapterControlBlock *acb)
 {
-	char *acb_firm_model=acb->firm_model;
-	char *acb_firm_version=acb->firm_version;
+	char *acb_firm_model = acb->firm_model;
+	char *acb_firm_version = acb->firm_version;
 	char *acb_device_map = acb->device_map;
-	size_t iop_firm_model=offsetof(struct HBB_RWBUFFER, msgcode_rwbuffer[ARCMSR_FW_MODEL_OFFSET]);	/*firm_model,15,60-67*/
-	size_t iop_firm_version=offsetof(struct HBB_RWBUFFER, msgcode_rwbuffer[ARCMSR_FW_VERS_OFFSET]);	/*firm_version,17,68-83*/
+	size_t iop_firm_model = offsetof(struct HBB_RWBUFFER, msgcode_rwbuffer[ARCMSR_FW_MODEL_OFFSET]);	/*firm_model,15,60-67*/
+	size_t iop_firm_version = offsetof(struct HBB_RWBUFFER, msgcode_rwbuffer[ARCMSR_FW_VERS_OFFSET]);	/*firm_version,17,68-83*/
 	size_t iop_device_map = offsetof(struct HBB_RWBUFFER, msgcode_rwbuffer[ARCMSR_FW_DEVMAP_OFFSET]);
 	int i;
 
